// SETA43
//20-06-2016
// http://www.seta43.netau.net/electro.html
//_________________________________

#include <Wire.h>
 
#define EEPROM_I2C_ADDRESS 0x50
#define MIDELAY 1 
 
char entrada[100]="LedFelipe"; 
int contador;
boolean stringComplete = true; 
int Direccion;
byte Dato;


int maxaddress=127; 
int address = 0;
unsigned int value = 0;
unsigned int check_value = 0;

char VARI[]="SETA43";

 
void setup(void)
{
  Serial.begin(115200);
  Wire.begin();
  Serial.println(" EMPIEZA 24CXX");  
}
 
void loop()
{ 
  unsigned char c;
  unsigned int z;
 
   while (Serial.available())
    {
      char inChar = (char)Serial.read(); 
      entrada[contador]=inChar;  
      if (inChar == '\n')
          {
            stringComplete = true;
            entrada[contador]=0;
          } 
      contador++;
    }
    
  if (stringComplete) 
    {        
      if(!strcmp(entrada,"RA_24C01"))   { maxaddress=127; readAll();   goto salto0;  }
      if(!strcmp(entrada,"RA_24C02"))   { maxaddress=255; readAll();   goto salto0;  }
      if(!strcmp(entrada,"RA_24C04"))   { maxaddress=511; readAll();   goto salto0;  }
      if(!strcmp(entrada,"RA_24C08"))   { maxaddress=1023; readAll();  goto salto0;  }    
      if(!strcmp(entrada,"RA_24C16"))   { maxaddress=2047; readAll();  goto salto0;  }    
          
      if(!memcmp(entrada,"WD",2))
          { writeDirec();   Serial.println("OK_Dwrite");  goto salto0;  }          
salto0:     
     contador=0;
     stringComplete = false;
    } 
}
 
 
 
int writeDirec()
{
 int z,d1,d2;

   d1=d2=255;
   for(z=0;z<100;z++)
     {  
       if(entrada[z]==',')
         {
           entrada[z]=0;
           if(d1==255)
            { d1=z+1;}
            else
            {  if(d2==255) d2=z+1;}            
         }        
     }
    Direccion=atoi(entrada+d1);
    Dato=atoi(entrada+d2);
    writeEEPROM(EEPROM_I2C_ADDRESS, Direccion,Dato); 
   //  Serial.print("Dir "); Serial.print(d1); Serial.print("  Dat "); Serial.println(d2);
   //  Serial.print("Di-> "); Serial.print(Direccion); Serial.print(" Da-> "); Serial.println(Dato);
}
 
void readAll()
 {
   unsigned int z;
   unsigned char c;

    for(z=0;z<=maxaddress;z++)
               {
                 c= readEEPROM(EEPROM_I2C_ADDRESS,z);
                 Serial.print("DI"); Serial.print(",");
                 Serial.print(z);Serial.print(",");
                 Serial.println(c,DEC);
                 delay(MIDELAY);
               }
    Serial.println("END_READ");
 }
 
 
 
void writeEEPROM(int deviceaddress, unsigned int eeaddress, byte data ) 
{
  if (maxaddress <= 255) //24c01 24c02
   {
    Wire.beginTransmission(deviceaddress);
    Wire.write((int)(eeaddress));
    Wire.write(data);
    Wire.endTransmission();
   }
   
  if(maxaddress == 511 || maxaddress == 1023 || maxaddress == 2047)   //24c04 24c08 24c16
   {
    //if(eeaddress>255) 
    deviceaddress=deviceaddress | (eeaddress >> 8) ; 
    Wire.beginTransmission(deviceaddress);
    Wire.write((int)(eeaddress));
    Wire.write(data);
    Wire.endTransmission();
   }
   
  delay(5);
}
 
byte readEEPROM(int deviceaddress, unsigned int eeaddress ) 
{
  byte rdata = 0xFF;
  
  if(maxaddress <= 255) //24c01 24c02
   {
    Wire.beginTransmission(deviceaddress);
    Wire.write((int)(eeaddress));
    Wire.endTransmission();
   }
  
  if(maxaddress == 511 || maxaddress == 1023 || maxaddress == 2047)   //24c04 24c08 24c16
   {
    //if(eeaddress>255)      
    deviceaddress=deviceaddress | (eeaddress >> 8) ;
    Wire.beginTransmission(deviceaddress);
    Wire.write((int)(eeaddress));
    Wire.endTransmission();
   }
  
   Wire.requestFrom(deviceaddress,1); 
   if (Wire.available()) rdata = Wire.read(); 
   return rdata;
}
